(* include/lber_types.h.  Generated by configure.  *)
(* $OpenLDAP: pkg/ldap/include/lber_types.h.in,v 1.10.2.3 2005/01/20 17:00:58 kurt Exp $ *)
(* This work is part of OpenLDAP Software <http://www.openldap.org/>.
 *
 * Copyright 1998-2005 The OpenLDAP Foundation.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted only as authorized by the OpenLDAP
 * Public License.
 *
 * A copy of this license is available in file LICENSE in the
 * top-level directory of the distribution or, alternatively, at
 * <http://www.OpenLDAP.org/license.html>.
 *)

(*
 * LBER types
 *)

uses
  ctypes;

type
  ppcchar                           = ^pcchar;
  pppcchar                          = ^ppcchar;

(* LBER Boolean, enum, integers (32 bits or larger) *)
  LBER_INT_T                        = cint;

(* LBER tags (32 bits or larger) *)
  LBER_TAG_T                        = clong;

(* LBER socket descriptor *)
  LBER_SOCKET_T                     = cint;

(* LBER lengths (32 bits or larger) *)
  LBER_LEN_T                        = clong;

(* ------------------------------------------------------------ *)

(* Booleans, enumerations, and integers *)
  pber_int_t                        = ^ber_int_t;
  ber_int_t                         = cint;      // LBER_INT_T;

(* signed and unsigned versions *)
  pber_sint_t                       = ^ber_sint_t;
  ber_sint_t                        = csint;     // signed LBER_INT_T

  pber_uint_t                       = ^ber_uint_t;
  ber_uint_t                        = cuint;     // unsigned LBER_INT_T

(* tags *)
  pber_tag_t                        = ^ber_tag_t;
  ber_tag_t                         = culong;    // unsigned LBER_TAG_T

(* "socket" descriptors *)
  pber_socket_t                     = ^ber_socket_t;
  ber_socket_t                      = cint;      // LBER_SOCKET_T

(* lengths *)
  pber_len_t                        = ^ber_len_t;
  ber_len_t                         = culong;    // unsigned LBER_LEN_T

(* signed lengths *)
  pber_slen_t                       = ^ber_slen_t;
  ber_slen_t                        = clong;     // signed LBER_LEN_T;
