{
    Free Pascal port of the OpenPTC C++ library.
    Copyright (C) 2001-2010  Nikolay Nikolov (nickysn@users.sourceforge.net)
    Original C++ version by Glenn Fiedler (ptc@gaffer.org)

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version
    with the following modification:

    As a special exception, the copyright holders of this library give you
    permission to link this library with independent modules to produce an
    executable, regardless of the license terms of these independent modules,and
    to copy and distribute the resulting executable under terms of your choice,
    provided that you also meet, for each linked independent module, the terms
    and conditions of the license of that module. An independent module is a
    module which is not derived from or based on this library. If you modify
    this library, you may extend this exception to your version of the library,
    but you are not obligated to do so. If you do not wish to do so, delete this
    exception statement from your version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
}

function ptc_format_create: TPTC_FORMAT;
begin
  try
    ptc_format_create := TPTC_FORMAT(TPTCFormat.Create);
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_create := nil;
    end;
  end;
end;

function ptc_format_create_indexed(bits: Integer): TPTC_FORMAT;
begin
  try
    ptc_format_create_indexed := TPTC_FORMAT(TPTCFormat.Create(bits));
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_create_indexed := nil;
    end;
  end;
end;

function ptc_format_create_direct(bits: Integer; r, g, b, a: int32): TPTC_FORMAT;
begin
  try
    ptc_format_create_direct := TPTC_FORMAT(TPTCFormat.Create(bits, r, g, b, a));
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_create_direct := nil;
    end;
  end;
end;

procedure ptc_format_destroy(obj: TPTC_FORMAT);
begin
  if obj = nil then
    exit;
  try
    TPTCFormat(obj).Destroy;
  except
    on error: TPTCError do
      ptc_exception_handle(error);
  end;
end;

function ptc_format_r(obj: TPTC_FORMAT): int32;
begin
  try
    ptc_format_r := TPTCFormat(obj).r;
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_r := 0;
    end;
  end;
end;

function ptc_format_g(obj: TPTC_FORMAT): int32;
begin
  try
    ptc_format_g := TPTCFormat(obj).g;
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_g := 0;
    end;
  end;
end;

function ptc_format_b(obj: TPTC_FORMAT): int32;
begin
  try
    ptc_format_b := TPTCFormat(obj).b;
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_b := 0;
    end;
  end;
end;

function ptc_format_a(obj: TPTC_FORMAT): int32;
begin
  try
    ptc_format_a := TPTCFormat(obj).a;
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_a := 0;
    end;
  end;
end;

function ptc_format_bits(obj: TPTC_FORMAT): Integer;
begin
  try
    ptc_format_bits := TPTCFormat(obj).bits;
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_bits := 0;
    end;
  end;
end;

function ptc_format_bytes(obj: TPTC_FORMAT): Integer;
begin
  try
    ptc_format_bytes := TPTCFormat(obj).bytes;
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_bytes := 0;
    end;
  end;
end;

function ptc_format_direct(obj: TPTC_FORMAT): Boolean;
begin
  try
    ptc_format_direct := TPTCFormat(obj).direct;
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_direct := False;
    end;
  end;
end;

function ptc_format_indexed(obj: TPTC_FORMAT): Boolean;
begin
  try
    ptc_format_indexed := TPTCFormat(obj).indexed;
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_indexed := False;
    end;
  end;
end;

procedure ptc_format_assign(obj, format: TPTC_FORMAT);
begin
  try
    TPTCFormat(obj).Assign(TPTCFormat(format));
  except
    on error: TPTCError do
      ptc_exception_handle(error);
  end;
end;

function ptc_format_equals(obj, format: TPTC_FORMAT): Boolean;
begin
  try
    ptc_format_equals := TPTCFormat(obj).Equals(TPTCFormat(format));
  except
    on error: TPTCError do
    begin
      ptc_exception_handle(error);
      ptc_format_equals := False;
    end;
  end;
end;
